"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function PgOrderAllColumnsPlugin(builder, _ref) {
  var inflection = _ref.pgInflection;

  builder.hook("GraphQLEnumType:values", function (values, _ref2, _ref3) {
    var extend = _ref2.extend,
        introspectionResultsByKind = _ref2.pgIntrospectionResultsByKind;
    var _ref3$scope = _ref3.scope,
        isPgRowSortEnum = _ref3$scope.isPgRowSortEnum,
        table = _ref3$scope.pgIntrospection;

    if (!isPgRowSortEnum || !table || table.kind !== "class") {
      return values;
    }
    return extend(values, introspectionResultsByKind.attribute.filter(function (attr) {
      return attr.classId === table.id;
    }).reduce(function (memo, attr) {
      var ascFieldName = inflection.orderByEnum(attr.name, true, table.name, table.namespaceName);
      var descFieldName = inflection.orderByEnum(attr.name, false, table.name, table.namespaceName);
      memo[ascFieldName] = {
        value: {
          alias: ascFieldName.toLowerCase(),
          specs: [[attr.name, true]]
        }
      };
      memo[descFieldName] = {
        value: {
          alias: descFieldName.toLowerCase(),
          specs: [[attr.name, false]]
        }
      };
      return memo;
    }, {}));
  });
};
//# sourceMappingURL=PgOrderAllColumnsPlugin.js.map